/*
 * $Copyright Open Broadcom Corporation$
 *
 * $Id: wandsllinkconfig.h,v 1.11.32.2 2003/10/31 21:31:35 mthawani Exp $
 */

#ifndef _wandsllinkconfig_h
#define _wandsllinkconfig_h

typedef enum { 
    DSL_LINK_EoA, 
    DSL_LINK_IPoA, 
    DSL_LINK_PPoA,
    DSL_LINK_PPoE,
    DSL_LINK_CIP,
    DSL_LINK_UNCONFIGURED 
} dsl_link_t;

typedef enum { 
    DSL_LINK_UP, 
    DSL_LINK_DOWN, 
    DSL_LINK_INITIALIZING,
    DSL_LINK_UNAVAILABLE 
} dsl_conn_t;


struct WANDSLLinkConfigData {
    dsl_link_t  link_type;
    dsl_conn_t	link_status;
    int		autoconfig;
    timer_t     eventhandle;
};

typedef struct WANDSLLinkConfigData WANDSLLinkConfigData, *PWANDSLLinkConfigData;

#endif // _wandsllinkconfig_h
