/*
 * $Copyright Open Broadcom Corporation$
 *
 * $Id: mapmgr.h,v 1.2.32.2 2003/10/31 21:31:35 mthawani Exp $
 */

#ifndef _mapmgr_h_
#define _mapmgr_h_

typedef struct _netconf_nat_t mapping_t;

void mapmgr_update();
bool mapmgr_get_port_map(int n, mapping_t *m);
bool mapmgr_add_port_map(mapping_t *m);
bool mapmgr_delete_port_map(int n);
bool mapmgr_get_range_map(int n, mapping_t *m);
bool mapmgr_add_range_map(mapping_t *m);
bool mapmgr_delete_range_map(int n);
int mapmgr_port_map_count();
int mapmgr_range_map_count();

#define MAX_PORT_MAPPINGS FD_SETSIZE


#endif /* _mapmgr_h_ */
